try (destroydialog ov_scene_export_main)
catch()

global ov_scene_export_main = undefined
global scene_exporter_2Darray = #()
global scene_exporter_wirecolors = #()
rci = rolloutCreator "ov_scene_export_main" "scene exporter"

rci.begin()

rci.addcontrol #groupbox #gpbx_01 "assign object id's" paramStr:"pos:[5,5] width:220 height:225 "
rci.addcontrol #dropdownlist #ddl_show "show in viewport" paramStr:"pos:[15,180] width:200 height:20 "
rci.addcontrol #button #btn_bywirecol "by wirecolor" paramStr:"pos:[15,150] width:200 height:20 "
rci.addcontrol #groupbox #gpbx_02 "export scene" paramStr:"pos:[5,240] width:220 height:90 "
rci.addcontrol #checkbox #chbx_01 "create multi-matte-elements" paramStr:"pos:[15,260] checked:true "
rci.addcontrol #checkbox #chbx_02 "create standard vray elements" paramStr:"pos:[15,280] checked:true "
rci.addcontrol #button #btn_go "GO! (rightclick - refresh)" paramStr:"pos:[15,300] width:200 height:20 " 

l = -5
r = 25
rci.addhandler #ov_scene_export_main #open codeStr:" test() "
rci.addhandler #ov_scene_export_main #close codeStr:" ov_scene_export_main_startwirecolors = #(); ov_scene_export_main.ddl_show.selection = 1; showVP() "

for i =1 to 60 do(
	if i == 11 then (r=45)
	if i == 21 then (r=65)
	if i == 31 then (r=85)
	if i == 41 then (r=105)
	if i == 51 then (r=125)
	l += 20
	if l > 200 then (l=15)
	a = execute ("#chbtn" + (i as string))
	b = "pos:[" + (l as string) + ","+ (r as string) +"] width:18 height:18 "
	rci.addControl #checkbutton a ("" + (i as string)) paramStr:b
	callfn = ("(handler " + (i as string) + " value:val" + ")")
	rci.addHandler a #changed codeStr:callfn paramStr:"val " 
	callfnii = ("sele (" + (i as string) + ")")
	rci.addHandler a #rightclick codeStr:callfnii
	rci.addHandler #btn_go #pressed codeStr:"go_handler ()"
	rci.addHandler #btn_go #rightclick codeStr:"test ()"
	)
	
	rci.addHandler #btn_bywirecol #pressed codeStr:"bywc()"
	rci.addHandler #ddl_show #selected paramstr:"val " codeStr:"showVP() "
	
	
	fn test = (
	--stores wirecolors and objects
	scene_exporter_wirecolors = #()
	scene_exporter_2Darray = #()
	for a in geometry do(
		appendifunique scene_exporter_wirecolors a.wirecolor
	)
		
	for a in scene_exporter_wirecolors do(
		objarray = #()
		for b in geometry do(
			if b.wirecolor == a then append objarray b
		)
		append scene_exporter_2Darray objarray
	)
	
	it = ov_scene_export_main.ddl_show.items
	if ov_scene_export_main.ddl_show.selected != "show shaded viewport" and it.count != 0 then(showVP())
	
	for i=8 to 67 do(
		ov_scene_export_main.controls[i].checked = false
	)
	for i in geometry do (
		if i.gbufferchannel > 60 then (i.gbufferchannel = 60)
		if i.gbufferchannel < 1 then (i.gbufferchannel = 1)
			ov_scene_export_main.controls[((i.gbufferchannel)+7)].checked = true
		)
	items = ov_scene_export_main.ddl_show.items
	if items.count == 0 then(
		items = #()
		append items "show shaded viewport"
		for i = 1 to 60  by 3 do(
			append items ("id " + (i as string) + " to " + ((i+2) as string))
		)
		ov_scene_export_main.ddl_show.items = items
	)
)
	
fn bywc=(
	colors = #()
	for a in geometry do(
		appendifunique colors a.wirecolor
	)
	if colors.count > 60 then(
		messagebox "there are more colors in the scene then object-ID-Slots (so more then 60), overlapping will occour"
	)
	idcount = 1
	for a in colors do(
		for b in objects do(
			if b.wirecolor == a then b.gbufferchannel = idcount
		)
		idcount +=1
		if idcount == 61 then idcount = 1
	)
	try(test())
		catch(destroydialog ov_scene_export_main)
)

fn showVP=(
	
	if ov_scene_export_main.ddl_show.selected != "show shaded viewport" then(
		
		ids = ov_scene_export_main.ddl_show.selected
		ids = replace ids 1 3 ""
		index = findstring ids "to"
		id = substring ids 1 (index-2)
		idn = id as integer
		for a in objects do(
			if a.gbufferchannel != idn and a.gbufferchannel != (idn+1) and a.gbufferchannel != (idn+2) then a.wirecolor = (color 0 0 0)
			if a.gbufferchannel == idn then a.wirecolor = (color 255 0 0)
			if a.gbufferchannel == (idn+1) then a.wirecolor = (color 0 255 0)
			if a.gbufferchannel == (idn+2) then a.wirecolor = (color 0 0 255)
			ov_scene_export_main.btn_bywirecol.enabled = false
		)
		if displayColor.shaded != #object then(
			displayColor.shaded = #object
			actionMan.executeAction 0 "554"
		)
	)
	else (
	index = 1
		for a in scene_exporter_wirecolors do(
			for b in scene_exporter_2Darray[index] do(
				b.wirecolor = a
			)
			index += 1
		)
		ov_scene_export_main.btn_bywirecol.enabled = true
		if displayColor.shaded != #material then(
			displayColor.shaded = #material
			actionMan.executeAction 0 "549"
		)
	)
)
	
	



		
fn handler id value:True = (
	sel = selection
		for i in sel do(
			i.gbufferchannel = id
		)
		test ()
)

fn sele id = (
	sel = #()
		for i in geometry do(
			if i.gbufferchannel == id then (append sel i)
		)
		select sel
		test ()
)






fn go_handler =(
	elementlist = #(vraydiffusefilter, vrayextratex, vrayalpha, vrayglobalillumination, vraylighting, vrayrawglobalillumination, vrayrawlighting, vrayreflection, vrayrefraction, vrayspecular, vrayselfillumination, vrayshadow, vraywirecolor)
	re = maxOps.GetCurRenderElementMgr()
	min = 60
	maxi = 0
	for i in geometry do(
		if i.gbufferchannel > maxi then (maxi = i.gbufferchannel)
		if i.gbufferchannel < min then (min = i.gbufferchannel)
	)
	
	re.removeallrenderelements()
	
	
	if ov_scene_export_main.chbx_02.checked == true then(

for n in elementlist do(
	a = units.SystemType
	rad = 10
	if a == #Millimeters then( rad = 120)
	if a == #Centimeters then (rad = 12)
	if a == #Meters then (rad = 0.12)
	if n== vrayextratex then(
		re.addrenderelement (n  vrayVFB:False texture:(VrayDirt radius:rad subdivs:16 falloff: 0.5) elementname:"VrayAO_")	
	)
	if n != vrayextratex then(
	re.addrenderelement (n elementname:((n as string)+"_")vrayVFB:False)
	format "\nAdded % renderelement" n
		)
	)
)
	if ov_scene_export_main.chbx_01.checked == true then(
count = 1
	for i=min to maxi by 3 do(
		re.addrenderelement (multimatteelement  elementname:("MultiMatteElement_" + (count as string)+"_") R_gbufIDOn:true G_gbufIDOn:True  B_gbufIDOn:True vrayVFB:False R_gbufID:i G_gbufID:(i+1) B_gbufID:(i+2))
		count +=1
	)
)
)




createDialog (rci.end()) 230 340
